<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:tns="http://www.oasis-open.org/tc/ebxml-iic/conformance/reqs">
	<xsl:output method="html"/>
	<xsl:template match="/">
		<table border="2">
			<xsl:apply-templates/>
		</table>
	</xsl:template>
	<xsl:template match="tns:Requirements">
		<tr>
			<td>
				<h4>Requirement ID</h4>
			</td>
			<td>
				<h4>Name</h4>
			</td>
			<td>
				<h4>Type</h4>
			</td>
			<td>
				<h4>Function</h4>
			</td>
			<td>
				<h4>Specification Ref</h4>
			</td>
			<td>
				<h4>Condition</h4>
			</td>
			<td>
				<h4>Assertion</h4>
			</td>
		</tr>
		<xsl:apply-templates/>
	</xsl:template>
	<xsl:template match="tns:TestRequirement">
		<xsl:choose>
			<xsl:when test="@requirementType='required'">
				<tr bgcolor="668866">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
				</tr>
			</xsl:when>
			<xsl:when test="@requirementType='recommended'">
				<tr bgcolor="666688">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
				</tr>
			</xsl:when>
			<xsl:when test="@requirementType='not recommended'">
				<tr bgcolor="886666">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
				</tr>
			</xsl:when>
			<xsl:when test="@requirementType='optional'">
				<tr bgcolor="888866">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
				</tr>
			</xsl:when>
			<xsl:otherwise>
				<tr/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:apply-templates/>
	</xsl:template>
	<xsl:template match="tns:SemanticRequirement">
		<xsl:choose>
			<xsl:when test="@requirementType='required'">
				<tr bgcolor="668866">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
					<xsl:choose>
						<xsl:when test="tns:Condition">
							<xsl:apply-templates select="tns:Condition"/>
						</xsl:when>
						<xsl:otherwise>
							<td/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:apply-templates select="tns:Assertion"/>
				</tr>
			</xsl:when>
			<xsl:when test="@requirementType='recommended'">
				<tr bgcolor="666688">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
					<xsl:choose>
						<xsl:when test="tns:Condition">
							<xsl:apply-templates select="tns:Condition"/>
						</xsl:when>
						<xsl:otherwise>
							<td/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:apply-templates select="tns:Assertion"/>
				</tr>
			</xsl:when>
			<xsl:when test="@requirementType='not recommended'">
				<tr bgcolor="886666">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
					<xsl:choose>
						<xsl:when test="tns:Condition">
							<xsl:apply-templates select="tns:Condition"/>
						</xsl:when>
						<xsl:otherwise>
							<td/>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:apply-templates select="tns:Assertion"/>
				</tr>
			</xsl:when>
			<xsl:when test="@requirementType='optional'">
				<tr bgcolor="888866">
					<td>
						<xsl:value-of select="@id"/>
					</td>
					<td>
						<xsl:value-of select="@name"/>
					</td>
					<td>
						<xsl:value-of select="@requirementType"/>
					</td>
					<td>
						<xsl:value-of select="@functionalType"/>
					</td>
					<td>
						<xsl:value-of select="@specRef"/>
					</td>
				</tr>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="tns:Condition">
		<td>
			<xsl:value-of select="."/>
		</td>
	</xsl:template>
	<xsl:template match="tns:Assertion">
		<td>
			<xsl:value-of select="."/>
		</td>
	</xsl:template>
</xsl:stylesheet>
