package com.xmlglobal.ebxml.iic;

import org.oasis.ebxmliic.ms.*;
import java.util.*;
import java.io.*;
import org.jdom.*;
import org.jdom.output.*;

public class RequirementsImpl
    extends EventHelper
    implements Requirements
{
    public static final Namespace NS_REQS = 
        Namespace.getNamespace("http://www.oasis-open.org/tc/ebxml-iic/conformance/reqs");
    private List mTestReqs = new ArrayList();
    
    public TestRequirement createTestRequirement()
    {
        return new TestRequirementImpl();
    }
    
    public void addTestRequirement(TestRequirement tr)
    {
        mTestReqs.add(tr);
    }
    
    public void removeTestRequirement(TestRequirement tr)
    {
        mTestReqs.remove(mTestReqs.indexOf(tr));
    }
    
    public TestRequirement getTestRequirement(int idx)
    {
        if (idx > mTestReqs.size()) return null;
        return (TestRequirement)mTestReqs.get(idx);
    }
    
    public int countTestRequirements()
    {
        return mTestReqs.size();
    }
    
    public List getAllTestRequirements()
    {
        return mTestReqs;
    }
    public void removeAllTestRequirements()
    {
        mTestReqs.clear();
    }
    
    public void writeTo(java.io.OutputStream os) 
        throws IOException
    {
        XMLOutputter xo = new XMLOutputter("  ", true);
        xo.output(new Document(serialize()), os);
    }
    
    public void addTestListener(TestListener tl)
    {
       addListener(tl);
    }
    
    public void removeTestListener(TestListener tl)
    {
        removeListener(tl);
    }
    
    public void executeTests()
    {
        for (int i = 0; i < mTestReqs.size(); i++)
        {
            TestRequirement tr = (TestRequirement)mTestReqs.get(i);
            tr.setTestListeners(mLstnrs);
            tr.executeTest();
        }
    }
    
    public void createFromElement(Element e)
    {
        List trs = e.getChildren("TestRequirement", NS_REQS);
        for (int i = 0; i < trs.size(); i++)
        {
            TestRequirement tr = createTestRequirement();
            tr.createFromElement((Element)trs.get(i));
            addTestRequirement(tr);
        }   
    }    
    
    public Element serialize()
    {
        Element r = new Element("Requirements", NS_REQS);
        for (int i = 0; i < mTestReqs.size(); i++)
        {
            TestRequirement tr = (TestRequirement)mTestReqs.get(i);
            r.addContent(tr.serialize());
        }
        return r;
    }
}
