package com.xmlglobal.ebxml.iic;

import org.oasis.ebxmliic.ms.*;
import java.util.*;
import java.io.*;
import org.jdom.*;
import org.jdom.output.*;
import org.apache.tools.ant.*;


public class TestRequirementImpl
    extends EventHelper
    implements TestRequirement
{
    private List mSemReqs = new ArrayList();
    private String mId;
    private String mSpecRef;
    private String mName;
    private String mFunctionalType;
    private BuildListener antLstnr;
    private AntExecutor antExec;
                        
    public TestRequirementImpl()
    {
        try
        {
            antLstnr = new AntBuildListener(this);
            String b_file = System.getProperty("BUILD_FILE");
            antExec = new AntExecutor(
                            new File(b_file), antLstnr);
        } 
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
    
    public SemanticRequirement createSemanticRequirement()
    {
        return new SemanticRequirementImpl();
    }
    
    public void addSemanticRequirement(SemanticRequirement s)
    {
        mSemReqs.add(s);   
    }
    
    public void removeSemanticRequirement(SemanticRequirement sr)
    {
        mSemReqs.remove(mSemReqs.indexOf(sr));
    }
    public SemanticRequirement getSemanticRequirement(int idx)
    {
        if (idx > mSemReqs.size()) return null;
        return (SemanticRequirement)mSemReqs.get(idx);
    }
    public int countSemanticRequirements()
    {
        return mSemReqs.size();
    }
    public List getAllSemanticRequirements()
    {
        return mSemReqs;
    }
    public void removeAllSemanticRequirements()
    {
        mSemReqs.clear();
    }
    
    public void writeTo(java.io.OutputStream os) 
        throws IOException
    {
        XMLOutputter xo = new XMLOutputter("  ", true);
        xo.output(serialize(), os);   
    }
    
    public void executeTest()
    {
        antExec.execute(mId);  
    }
    
    public void setId(String id)
    {
        this.mId = id;
    }
    public String getId()
    {
        return this.mId;
    }
    
    public void setSpecRef(String sr)
    {
        this.mSpecRef = sr;
    }
    
    public String getSpecRef()
    {
        return this.mSpecRef;
    }
    public void setName(String name)
    {
        this.mName = name;
    }
    
    public String getName()
    {
        return this.mName;
    }
    
    public void setFunctionalType(String ft)
    {
        this.mFunctionalType = ft;
    }
    
    public String getFunctionalType()
    {
        return this.mFunctionalType;
    }
    

   public void setTestListeners(List l)
   {
        setListeners(l);
   }
    
    public void createFromElement(Element e)
    {
        List trs = e.getChildren("SemanticRequirement",
				RequirementsImpl.NS_REQS);
        for (int i = 0; i < trs.size(); i++)
        {
            SemanticRequirement tr = createSemanticRequirement();
            tr.createFromElement((Element)trs.get(i));
            addSemanticRequirement(tr);
        }   
        setId(e.getAttributeValue("id"));
        setName(e.getAttributeValue("name"));
        setFunctionalType(e.getAttributeValue("functionalType"));
        setSpecRef(e.getAttributeValue("specRef"));
    }    
    
    public Element serialize()
    {
        Element r = new Element("TestRequirement");
        for (int i = 0; i < mSemReqs.size(); i++)
        {
            SemanticRequirement tr = (SemanticRequirement)mSemReqs.get(i);
            r.addContent(tr.serialize());
        }
        return r;
    }
}

class AntBuildListener
    implements BuildListener
{
    Object mTr;
    
    public AntBuildListener(Object tr)
    {
        this.mTr = tr;
    }
    public void buildStarted(BuildEvent event)
    {
    }
    public void buildFinished(BuildEvent event)
    {
    }

    public void targetStarted(BuildEvent event)
    {
        TestEvent te = new TestEvent((TestRequirement)mTr);
        ((EventHelper)mTr).fireTestStarted(te);      
    }

    public void targetFinished(BuildEvent event) 
    {
        TestEvent te = new TestEvent((TestRequirement)mTr);
        ((EventHelper)mTr).fireTestPassed(te);
    }

    public void taskStarted(BuildEvent event)
    {
    }

    public void taskFinished(BuildEvent event)
    {
    }

    public void messageLogged(BuildEvent event)
    {
    }
}
