package org.oasis.ebxmliic.ms;
import java.io.*;


public class Driver
{
    public static final String DEFAULT_FACTORY 
        = "com.xmlglobal.ebxml.iic.RequirementsBuilderFactoryImpl";
    
    
    public static void main(String[] argv)
        throws Exception
    {
        String driverClassName = System.getProperty("ebxml.iic.ms.factory", 
                                                    DEFAULT_FACTORY);
        
        if (argv.length < 1)
        {
            System.out.println(Driver.class.getName() + " <requirements xml>");
            System.exit(1);
        }                                            
        
        RequirementsBuilderFactory factory = 
                                    (RequirementsBuilderFactory)
                                    (Class.forName(driverClassName).newInstance());
                             
        RequirementsBuilder bldr = factory.createRequirementsBuilder();
        Requirements r = bldr.build(new FileInputStream(argv[0]));
        r.addTestListener(new SimpleTestListener());
        r.executeTests();
    }
}

class SimpleTestListener
    implements TestListener
{
    public void testStarted(TestEvent te)
    {
        TestRequirement tr = (TestRequirement)te.getSource();
        System.out.println("----> " + tr.getName() + " STARTED");
    }
    
    public void testPassed(TestEvent te)
    {
        TestRequirement tr = (TestRequirement)te.getSource();
        System.out.println("----> " + tr.getName() + " PASSED");
    }
    
    public void testFailed(TestEvent te)
    {
        TestRequirement tr = (TestRequirement)te.getSource();
        System.out.println("----> " + tr.getName() + " FAILED");
    }
    
    
}